/* GCC */
#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;
#define DAY 1440
#define inf 1000000000
int n, m, t, a, b;
struct edge{
    int a, b, t0, t1, cost;
    edge(int q,int w, int c, int d, int e){
        a=q; b=w, t0=c, t1=d, cost=e;
    }
};
vector<vector<int> > stops;
vector<edge> edges;
vector<int> fastestTime, cheapestTime, fastestCost, cheapestCost;
int ans1, ans2, ans3, ans4;

void analyse(string s){
    int prevA, prevT, currA, currT, currCost;
    stringstream ss(s);
    ss>>prevA>>prevT>>currCost;
    stops[prevA][prevT]++;
    while(!ss.eof()){
        ss>>currA>>currT>>currCost;
        edges.push_back( edge(prevA, currA, prevT, currT, currCost) );
        stops[currA][currT]++;
        prevA=currA; prevT=currT;
    }
    stops[prevA][prevT]--;
}

void norm(edge &a){
    if(a.b==b) return;
    for(; a.t1<DAY && stops[a.b][a.t1]==0; a.t1++);
}

bool mycmp(edge a, edge b){
    return a.t0<b.t0;
}

void readData(){
    freopen("tax.in", "r", stdin);

    scanf("%d%d%d%d%d", &n, &m, &t, &a, &b);
    stops.assign(n+1, vector<int>(DAY+1));
    string s;
    getline(cin, s);
    for(int i=0; i<m; i++){
        getline(cin, s);
        analyse(s);
    }
    for(int i=0; i<edges.size(); i++) norm(edges[i]);
    sort(edges.begin(), edges.end(), mycmp);

    fclose(stdin);
}

void findFastest(vector<edge> edges){
    vector<int> time(n+1, inf), cost(n+1, inf);
    time[a]=t; cost[a]=0;
    vector<bool> used(edges.size(), false);
    bool isNew=true;
    for(int i=0; ; i=(i+1)%edges.size()){
        if(i==0){
            if(isNew){
                isNew=false;
            } else {
                break;
            }
        }
        int curr=edges[i].a, next=edges[i].b;
        if(time[curr]==inf) continue;
        for(; time[curr]>edges[i].t0; edges[i].t0+=DAY, edges[i].t1+=DAY);
        cout;

        if(!used[i]){
            used[i]=true;
            isNew=true;
        }
        if( time[next]==inf
           || time[next]>edges[i].t1
           || time[next]==edges[i].t1
              && cost[next]>cost[curr]+edges[i].cost )
        {
            time[next]=edges[i].t1;
            cost[next]=edges[i].cost+cost[curr];
        }
    }
    ans1=time[b]; ans2=cost[b];
}

void findCheapest(vector<edge> edges){
    vector<int> time(n+1, inf), cost(n+1, inf);
    time[a]=t; cost[a]=0;
    vector<bool> used(edges.size(), false);
    bool isNew=true;
    for(int i=0; ; i=(i+1)%edges.size()){
        if(i==0){
            if(isNew){
                isNew=false;
            } else {
                break;
            }
        }
        int curr=edges[i].a, next=edges[i].b;
        if(time[curr]==inf) continue;
        for(; time[curr]>edges[i].t0; edges[i].t0+=DAY, edges[i].t1+=DAY);
        cout;

        if(!used[i]){
            used[i]=true;
            isNew=true;
        }
        if( cost[next]==inf
           || cost[next]>cost[curr]+edges[i].cost
           || cost[next]==cost[curr]+edges[i].cost
              && time[next]>edges[i].t1)
        {
            time[next]=edges[i].t1;
            cost[next]=edges[i].cost+cost[curr];
        }
    }
    ans3=time[b]; ans4=cost[b];
}

void fileOut(){
    freopen("tax.out", "w", stdout);

    printf("%d %d\n%d %d\n", ans1, ans2, ans3, ans4);

    fclose(stdout);
}

int main(){
    readData();
    findFastest(edges);
    findCheapest(edges);
    fileOut();
    return 0;
}
