/* GCC */
#include <bits/stdc++.h>
#define MP make_pair
#define files(x) freopen(#x".in", "r", stdin); \
                 freopen(#x".out", "w", stdout)
struct edge {
    int to, tin, tout, cost;
    edge(int to, int tin, int tout, int cost):
        to(to), tin(tin), tout(tout), cost(cost) {}
};

using namespace std;
typedef pair<int, int> pii;
typedef set<int>::iterator sit;
const int inf = 1000*1000*1000 + 7;
vector< vector<edge> > graph;
vector< set<int> > times;
vector<pii> dist;
priority_queue< pair<pii, int> > q;
int V, start, fin, t0;
pii minc, mint;

pii operator*(const pii& p, bool f) {
    if (!f) return p;
    return MP(p.second, p.first);
}

pii dijkstra(bool f) {
    dist.assign(V+1, pii(inf, inf));
    dist[start] = MP(t0, 0)*f;
    q.push(MP(MP(-t0, 0)*f, start));
    while (!q.empty()) {
        int v = q.top().second;
        pii key = q.top().first*f;
        int t = -key.first, c = -key.second;
        q.pop();
        for (int i = 0; i < graph[v].size(); i++) {
            edge e = graph[v][i];
            while (e.tin < t) e.tout += 1440, e.tin += 1440;
            if (dist[e.to] > MP(e.tout, c+e.cost)*f) {
                dist[e.to] = MP(e.tout, c+e.cost)*f;
                q.push(MP(MP(-e.tout, -c-e.cost)*f, e.to));
            }
        }
    }
    return dist[fin]*f;
}

int main() {

    files(tax);
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

    int m, prevV, prevT, v, t, c;
    cin >> V >> m >> t0 >> start >> fin;
    string s;
    getline(cin, s);
    graph.resize(V+1);
    times.resize(V+1);

    while (m--) {
        getline(cin, s);
        stringstream ss(s);
        ss >> prevV >> prevT >> c;
        while (ss >> v >> t >> c) {
            graph[prevV].push_back(edge(v, prevT, t, c));
            times[prevV].insert(prevT);
            prevV = v, prevT = t;
        }
    }

    for (int v = 1; v <= V; v++) {
        for (int i = 0; i < graph[v].size(); i++) {
            edge& e = graph[v][i];
            if (e.to == fin) continue;
            sit it = times[e.to].upper_bound(e.tout-1);
            if (it == times[e.to].end())
                e.tout = 1440;
            else
                e.tout = *it;
        }
    }

    mint = dijkstra(0);
    minc = dijkstra(1);

    if (mint.first == minc.first && mint.second > minc.second)
        mint.second = minc.second;

    cout << mint.first << ' ' << mint.second << '\n';
    cout << minc.first << ' ' << minc.second << '\n';

    return 0;
}
