/* GCC */
#include <iostream>
#include <vector>
#include <cstdio>

using namespace std;

struct put{
    long to,arr,dep,cst;
};

long n,m,t,a,b;
vector <vector <put> > graf;
vector <long> tm,cs,lstm4tlc,lscs4tlt;
vector <bool> used;


void dijkstratime()
{
    for (long i = 0;i <= n;i++){
        long v = -1;
        for (long j = 1;j <= n;j++)
            if (!used[j]&&(v==-1||tm[j]<tm[v])) v = j;
        if (v==-1) break;
        used[v] = 1;
        for (long j  = 0;j < graf[v].size();j++)
        {
            long t = graf[v][j].to , arrives = graf[v][j].arr , departs = graf[v][j].dep, nw = tm[v];
            while(nw>departs)
            {
                departs+=1440;
                arrives+=1440;
            }
            if (tm[t]>arrives) tm[t]=arrives;
        }
    }
}

void dijkstramoney()
{
    for (long i = 0;i <= n;i++){
        long v = -1;
        for (long j = 1;j <= n;j++)
            if (!used[j]&&(v==-1||cs[j]<cs[v]))
                v = j;
        if (v == -1) break;
        used[v] = 1;
        for (long j = 0;j < graf[v].size();j++)
        {
            long t = graf[v][j].to,costs = graf[v][j].cst;
            if (cs[t]>cs[v]+costs) cs[t] = cs[v] + costs;
        }
    }
}

void dfstlcost(long v,long time_passed,long money_spent,long resourses)
{
    if (time_passed>lstm4tlc[v]) return;
    lstm4tlc[v]=time_passed;
    if (money_spent>resourses) return;
    for (long i = 0;i < graf[v].size();i++)
    {
        long t = graf[v][i].to , arrives = graf[v][i].arr , departs = graf[v][i].dep;
        while(departs<time_passed){
            departs+=1440;
            arrives+=1440;
        }
        if (money_spent+graf[v][i].cst<=resourses) dfstlcost(t,arrives,money_spent+graf[v][i].cst,resourses);
    }
}

void dfstltime(long v,long time_passed,long money_spent,long lmt)
{
    if (money_spent>lscs4tlt[v]) return;
    lscs4tlt[v]=money_spent;
    if (time_passed>lmt) return;
    for (long i = 0;i < graf[v].size();i++)
    {
        long t = graf[v][i].to , arrives = graf[v][i].arr , departs = graf[v][i].dep;
        while(departs<time_passed){
            departs+=1440;
            arrives+=1440;
        }
        if (arrives<=lmt) dfstltime(t,arrives,money_spent+graf[v][i].cst,lmt);
    }
}


int main()
{
    freopen("tax.in","r",stdin);
    freopen("tax.out","w",stdout);
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    cin>>n>>m>>t>>a>>b;
    tm.resize(n+1,9999999);
    cs.resize(n+1,9999999);
    used.resize(n+1,0);
    graf.resize(n+1);
    lstm4tlc.resize(n+1,9999999);
    lscs4tlt.resize(n+1,9999999);
    tm[a] = t;
    cs[a] = 0;
    long aa,bb,cc,la,lb,lc;
    while(cin>>aa>>bb>>cc)
    {
        if (cc!=0){
        put tp;
        tp.to = aa;
        tp.arr = bb;
        tp.dep = lb+1;
        tp.cst = cc;
        graf[la].push_back(tp);
        }
        la = aa;
        lb = bb;
        lc = cc;
    }
    dijkstratime();
    for (long i = 0;i <= n;i++)
        used[i] = 0;
    dijkstramoney();
    dfstltime(a,t,0,tm[b]);
    dfstlcost(a,t,0,cs[b]);
    long c11 = tm[b],c12 = lscs4tlt[b],c21 = lstm4tlc[b],c22 = cs[b];
    if (c11==c21) {
        c12=min(c12,c22);
        c22=c12;
    }
    if (c12==c22) {
        c21=min(c21,c11);
        c11=c21;
    }
    cout<<c11<<' '<<c12<<'\n'<<c21<<' '<<c22<<'\n';

    return 0;
}
